<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license   GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.controllerform');

class CobaltControllerSection extends JControllerForm
{

	public function __construct($config = array())
	{
		parent::__construct($config);

		if(!$this->input)
		{
			$this->input = JFactory::getApplication()->input;
		}
	}

	public function postSaveHook(JModelLegacy $model, $validData = array())
	{
		$task = $this->getTask();

		if($task == 'save2copy')
		{
			$new_id = $model->getState('section.id', 0);

			$new = JTable::getInstance('Section', 'CobaltTable');
			$new->load($new_id);
			$params = new JRegistry($new->params);
			$params->set('general.tmpl_markup', 'default.' . md5(time() . '-' . $new_id));
			$params->set('general.tmpl_list', 'default.' . md5(time() . '-' . $new_id));
			$params->set('general.tmpl_category', 'default.' . md5(time() . '-' . $new_id));
			$params->set('general.tmpl_compare', 'default.' . md5(time() . '-' . $new_id));
			$new->params = $params->toString();
			$new->store();
		}
	}

	protected function allowAdd($data = array())
	{
		$user  = JFactory::getUser();
		$allow = $user->authorise('core.create', 'com_cobalt.sections');

		if($allow === NULL)
		{
			return parent::allowAdd($data);
		}
		else
		{
			return $allow;
		}
	}

	protected function allowEdit($data = array(), $key = 'id')
	{
		return JFactory::getUser()->authorise('core.edit', 'com_cobalt.sections');
	}
}