<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.controllerform');

class CobaltControllerType extends JControllerForm
{

	public function __construct($config = array())
	{
		parent::__construct($config);

		if(!$this->input)
		{
			$this->input = JFactory::getApplication()->input;
		}
	}
	protected function allowAdd($data = array())
	{
		$user = JFactory::getUser();
		$allow = $user->authorise('core.create', 'com_cobalt.types');

		if($allow === null)
		{
			return parent::allowAdd($data);
		}
		else
		{
			return $allow;
		}
	}

	protected function allowEdit($data = array(), $key = 'id')
	{
		return JFactory::getUser()->authorise('core.edit', 'com_cobalt.types');
	}

	public function postSaveHook(JModelLegacy $model, $validData = array())
	{
		$task = $this->getTask();

		if ($task == 'save2copy')
		{
			$old_id = $this->input->getInt('id', 0);
			$new_id = $model->getState('type.id', 0);

			if (!$old_id || !$new_id)
			{
				return;
			}

			$old = JTable::getInstance('Type', 'CobaltTable');
			$old->load($old_id);

			$new = JTable::getInstance('Type', 'CobaltTable');
			$new->load($new_id);
			$params = new JRegistry($new->params);
			$params->set('properties.tmpl_article', 'default.'.md5(time().'-'.$new_id));
			$params->set('properties.tmpl_articleform', 'default.'.md5(time().'-'.$new_id));
			$params->set('properties.tmpl_rating', 'default.'.md5(time().'-'.$new_id));
			$params->set('properties.tmpl_comment', 'default.'.md5(time().'-'.$new_id));
			$new->params = $params->toString();
			$new->store();

			$db = JFactory::getDbo();
			$db->setQuery("INSERT INTO #__js_res_fields (`key`, label, type_id, field_type, params, published, ordering, access, group_id, asset_id, filter, user_id)
					SELECT `key`, label, $new_id, field_type, params, published, ordering, access, group_id, asset_id, filter, user_id
					FROM #__js_res_fields
					WHERE type_id = ".$old_id
			);
			$db->execute();

			$db->setQuery("SELECT * FROM #__js_res_fields_group WHERE type_id = ".$old_id);
			$groups = $db->loadObjectList();

			$db = JFactory::getDbo();
			include_once __DIR__.'/../tables/group.php';
			$gt = new CobaltTableGroup($db);
			foreach($groups AS $group)
			{
				$ogid = $group->id;
				$group->id = null;
				$group->type_id = $new_id;

				$gt->save($group);

				$db->setQuery("UPDATE #__js_res_fields SET group_id = $gt->id WHERE group_id = $ogid AND type_id = $new_id");
				$db->execute();

				$gt->reset();
				$gt->id = null;
			}
		}
	}
}