<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.html.html');
jimport('joomla.form.formfield');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class JFormFieldCobaltevents extends JFormField
{

	public $type = 'Cobaltevents';

	public function getInput()
	{
		$patern = '<tr><td nowrap="nowrap">%s</td><td>%s</td><td>%s</td><td nowrap="nowrap">%s</td><td nowrap="nowrap">%s</td></tr>';

		$html[] = '<table class="table table-striped">';
		$html[] = '<thead><tr><th>' . JText::_('CEVENT') . '</th>';
		$html[] = '<th width="100px">' . JText::_('CNOTIFICATIONS') . '</th>';
		$html[] = '<th width="100px">' . JText::_('CACTIVITY') . '</th>';
		$html[] = '<th width="5%" rel="tooltip" data-original-title="'.JText::_('CKARMACTDESCR').'">' . JText::_('CKARMAACTOR') . '</th>';
		$html[] = '<th width="5%" rel="tooltip" data-original-title="'.JText::_('CKARMTARGDESCR').'">' . JText::_('CKARMATARGET') . '</th>';
		$html[] = '</tr></thead><tbody>';

		$events = CEventsHelper::_events_list();

		foreach($events as $event => $karma)
		{
			$access = JHtml::_('access.level', $this->name . "[{$event}][notif]", isset($this->value->$event->notif) ? $this->value->$event->notif : 2,
				'class="span12"', array(JHtml::_('select.option', '0', JText::_('XML_OPT_NOONE'))));
			$act = JHtml::_('access.level', $this->name . "[{$event}][activ]", isset($this->value->$event->activ) ? $this->value->$event->activ : 2,
				'class="span12"', array(JHtml::_('select.option', '0', JText::_('XML_OPT_NOONE'))));
			$karma1 = sprintf('<input class="input-mini" type="text" size="3" value="%d" name="%s[%s][karma1]">',
				isset($this->value->$event->karma1) ? $this->value->$event->karma1 : 0, $this->name, $event);
			$karma2 = sprintf('<input class="input-mini" type="text" size="3" value="%d" name="%s[%s][karma2]">',
				isset($this->value->$event->karma2) ? $this->value->$event->karma2 : 0, $this->name, $event);
			$html[] = sprintf($patern, JText::_('EVENT_TYPE_'.$event), $access, $act, $karma[0] ? $karma1 : null, $karma[1] ? $karma2 : null);
		}
		$html[] = '</tbody></table>';

		return implode("\n", $html);
	}
}
