<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.view');

/**
 * View class for a list of users.
 *
 * @package		Joomla.Administrator
 * @subpackage	com_users
 * @since		1.6
 */
class CobaltViewUsers extends JViewLegacy
{
	protected $items;
	protected $pagination;
	protected $state;

	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
		$app = JFactory::getApplication();
		$user = JFactory::getUser();
		$access = true;
		if($type_id = $app->input->getInt('type_id', false))
		{
			$type = ItemsStore::getType($type_id);
			$tmpl_params = CTmpl::prepareTemplate('default_form_', 'properties.tmpl_articleform', $type->params);
			if(!in_array($tmpl_params->get('tmpl_core.form_show_user_id'), $user->getAuthorisedViewLevels()))
			{
				$access = false;
			}
		}
		elseif(!MECAccess::isModerator($user->get('id'), $app->input->getInt('filter_section', 0)))
		{
			$access = false;
		}

		if(!$access)
		{
			JError::raise(E_WARNING, 403, JText::_('CERR_NOPAGEACCESS'));
			return;
		}

		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		$this->state		= $this->get('State');

		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		parent::display($tpl);
	}

}
